
#include "dir.bi"
#include "file.bi"

declare function DirExists(byval aPath as string) as integer
declare sub BeautifyFile(byval aFilter as string, byval aPath as string, byval aOption as string)
declare sub BeautifyDirectory(byval aFilter as string, byval aPath as string, byval aOption as string)

const FBEAUTY = "c:\outils\formatters\fbeauty\fbeauty.exe"
const OPTION_UPCASE = ""
const OPTION_LOWCASE = "-l"
const OPTION_CAPITALIZED = "-c"
const OPTION_INDIVIDUAL = "-i"
const MY_OPTION = OPTION_LOWCASE

if FileExists(FBEAUTY) andalso Len(Command(1)) then
  if DirExists(Command(1)) then
    BeautifyDirectory(FBEAUTY, Command(1) & "\", MY_OPTION)
  elseif FileExists(Command(1)) then
    BeautifyFile(FBEAUTY, Command(1), MY_OPTION)
  end if
end if

function ChangeFileExt(byval aFileName as string, byval aExt as string) as string
  dim i as integer = InStrRev(aFileName, ".")
  if i = 0 then
    return aFileName
  else
    return Left(aFileName, i - 1) & aExt
  end if
end function

sub GenerateFile(byval aSource as string, byval aDest as string, byval aFilter as string, byval aOption as string)
  dim s as string
  open aDest for output as #1
  open pipe aFilter & " " & aOption & " < " & aSource for input as #2
  do until eof(2)
    line input #2, s
    print #1, s
  loop
  close #2
  close #1
end sub

sub GetExt(byval aPath as string, byval aExt as string, aArray() as string)
  dim i as integer = 0
  dim s as string = Dir(aPath & "*" & aExt, fbArchive)
  do while Len(s)
    redim preserve aArray(i) as string
    aArray(i) = s
    i += 1
    s = Dir()
  loop
end sub

sub ReplaceExt(byval aPath as string, byval aOldExt as string, byval aNewExt as string)
  dim s as string = Dir(aPath & "*" & aOldExt, fbArchive)
  do while Len(s)
    Name(aPath & s, aPath & ChangeFileExt(s, aNewExt))
    s = Dir()
  loop
end sub

sub DeleteExt(byval aPath as string, byval aExt as string)
  dim s as string
  s = Dir(aPath & "*" & aExt, fbArchive)
  do while Len(s)
    Kill(aPath & s)
    s = Dir()
  loop
end sub

function DirExists(byval aPath as string) as integer
  dim i as integer, s as string
  s = Dir(aPath, fbReadOnly or fbHidden or fbSystem or fbDirectory or fbArchive, i)
  if i and fbDirectory then
    return -1
  end if
  return 0
end function

sub BeautifyFile(byval aFilter as string, byval aPath as string, byval aOption as string)
  const BAS = ".bas"
  const TEMP = ".temp"
  Name(aPath, ChangeFileExt(aPath, TEMP))
  GenerateFile(ChangeFileExt(aPath, TEMP), aPath, aFilter, aOption)
  Kill(ChangeFileExt(aPath, TEMP))
end sub

sub BeautifyDirectory(byval aFilter as string, byval aPath as string, byval aOption as string)
  const BAS = ".bas"
  const TEMP = ".temp"
  dim array() as string
  ReplaceExt(aPath, BAS, TEMP)
  GetExt(aPath, TEMP, array())
  for i as integer = lbound(array) to ubound(array)
    GenerateFile(aPath & array(i), aPath & ChangeFileExt(array(i), BAS), aFilter, aOption)
  next i
  DeleteExt(aPath, TEMP)
end sub
